//#include <stdio.h>
//#include "wm_hal.h"

I2C_HandleTypeDef hi2c;
void Error_Handler(void);
static void I2C_Init(void);
static void GPIO_Init(void);
void scan();

#define DEVICE_ADDR    0xA0

void setup() {
  
 
    
    SystemClock_Config(CPU_CLK_160M);
   
    GPIO_Init();
    I2C_Init();
    scan();
  /*  for (i = 0; i < len; i++)
    {
        HAL_I2C_Write(&hi2c, DEVICE_ADDR, 0x00 + i, (uint8_t *)(w_buf + i), 1);
        HAL_Delay(10);
    }
    
    while (1)
    {
        memset(r_buf, 0, len);
        if (HAL_I2C_Read(&hi2c, DEVICE_ADDR, 0x00, r_buf, len) != HAL_OK)
        {
            printf("read failed\r\n");
        }
        if (memcmp(w_buf, r_buf, len))
        {
            printf("err: %s\r\n", r_buf);
        }
        i++;
        if ((i % 10000) == 0)
        {
            printf("i = %d\r\n", i);
        }
    }*/
}

void loop() {
  // put your main code here, to run repeatedly:
 HAL_Delay(1000);
}

void scan(){
    uint8_t address;
    int nDevices;
 
    printf("Scanning...\n");
 
    nDevices = 0;
    for(address = 8; address < 127; address++ ){

      HAL_I2C_Write_Byte(&hi2c, (address & 0xFE), 1);
      if (HAL_I2C_Wait_Ack(&hi2c) == HAL_OK)
      {
        
            printf("I2C device found at address %d\n", address);
           /* if (address<16)
                Serial.print("0");
            Serial.print(address,HEX);
            Serial.println(" !");*/
 
            nDevices++;
        }
        printf("\n");
        HAL_I2C_Stop(&hi2c);
        delay(10);
    }
    if (nDevices == 0)
        printf("No I2C devices found\n");
    else
        printf("done\n");
 
    delay(5000);
}




static void I2C_Init(void)
{

  __HAL_RCC_I2C_CLK_ENABLE();
    __HAL_AFIO_REMAP_I2C_SCL(GPIOA, GPIO_PIN_1);
    __HAL_AFIO_REMAP_I2C_SDA(GPIOA, GPIO_PIN_4);
    hi2c.Instance = I2C;
    hi2c.Frequency = 100000;
    HAL_I2C_Init(&hi2c);
}

static void GPIO_Init(void)
{
    GPIO_InitTypeDef GPIO_InitStruct = {0};
    __HAL_RCC_GPIO_CLK_ENABLE();
    GPIO_InitStruct.Pin = GPIO_PIN_1;
    GPIO_InitStruct.Mode = GPIO_MODE_OUTPUT;
    GPIO_InitStruct.Pull = GPIO_PULLUP;
    HAL_GPIO_Init(GPIOA, &GPIO_InitStruct);
    GPIO_InitStruct.Pin = GPIO_PIN_4;
    GPIO_InitStruct.Mode = GPIO_MODE_OUTPUT;
    GPIO_InitStruct.Pull = GPIO_PULLUP;
    HAL_GPIO_Init(GPIOA, &GPIO_InitStruct);
}


void HAL_I2C_MspInit(I2C_HandleTypeDef* hi2c)
{
    __HAL_RCC_I2C_CLK_ENABLE();
    __HAL_AFIO_REMAP_I2C_SCL(GPIOA, GPIO_PIN_1);
    __HAL_AFIO_REMAP_I2C_SDA(GPIOA, GPIO_PIN_4);
}

void HAL_I2C_MspDeInit(I2C_HandleTypeDef* hi2c)
{
    __HAL_RCC_I2C_CLK_DISABLE();
    HAL_GPIO_DeInit(GPIOA, GPIO_PIN_1);
    HAL_GPIO_DeInit(GPIOA, GPIO_PIN_4);
}

void HAL_MspInit(void)
{

}

void HAL_I2C_Write_Byte(I2C_HandleTypeDef *hi2c, uint8_t dat, uint8_t ifstart);
int HAL_I2C_Wait_Ack(I2C_HandleTypeDef *hi2c);
void HAL_I2C_Stop(I2C_HandleTypeDef *hi2c);
